<?php

function ipay88_kredivo_config() 
{
	$configarray_kredivo = 	array("FriendlyName" => array("Type" => "System", "Value"=>"Kredivo via iPay88"),
     				
							"merchant_code_kredivo" => array( "FriendlyName" => "Merchant Code", 
															  "Type" 		=> "text", 
															  "Size" 		=> "20"),
     				
							"merchant_key_kredivo" => array( "FriendlyName" => "Merchant Key", 
															 "Type" 		=> "text", 
															 "Size" 		=> "20"),
												
							"instructions_kredivo" => array( "FriendlyName" => "Payment Instructions", 
															 "Type" 		=> "textarea", 
													 		 "Rows" 		=> "5"),
							
							"environment_kredivo"  => array( "FriendlyName" => "Enable Sandbox", 
													 		 "Type" 		=> "yesno", 
													 		 "Description" 	=> "Sandbox mode provides you with a chance to test your gateway integration with iPay88. The payment requests will be send to the iPay88 sandbox URL. Untick to start accepting Live payments."));										 					
	
	return $configarray_kredivo;
}


function iPay88_kredivo_signature($source)
{
	return base64_encode(hex2bin(sha1($source)));
}


if (!function_exists('hex2bin'))
{
	function hex2bin($hexSource)
	{
		$bin = '';
		for ($i=0;$i<strlen($hexSource);$i=$i+2)
		{
			$bin .= chr(hexdec(substr($hexSource,$i,2)));
		}
		return $bin;
	}
}


function ipay88_kredivo_link($params) 
{
	global $CONFIG;

	// Invoice variables
	$invoiceId 		= $params['invoiceid'];
    $description 	= $params["description"];
    $amount			= $params['amount'];
    $currencyCode 	= $params['currency'];
	
	// Client Variables
	$client_data	= $params['clientdetails'];
	$client_userid	= $client_data['userid'];
	$client_id		= $client_data['id'];
	
	$firstname 		= $params['clientdetails']['firstname'];
	$lastname 		= $params['clientdetails']['lastname'];
	$fullname		= $params['clientdetails']['fullname'];
	
	$email 			= $params['clientdetails']['email'];
	$address1		= $params['clientdetails']['address1'];
	$address2 		= $params['clientdetails']['address2'];
	$city 			= $params['clientdetails']['city'];
	$state 			= $params['clientdetails']['state'];
	$postcode 		= $params['clientdetails']['postcode'];
	$country 		= $params['clientdetails']['country'];
	$phone 			= $params['clientdetails']['phonenumber'];
	
	$validateurl	= $CONFIG['SystemURL']."/modules/gateways/callback/ipay88_kredivo_validate.php";	

	$code =
	'<br><center>
	
	<form method="post" name="ePayment" action="'.$validateurl.'">	
	
		<input type="hidden" name="invoiceId" 		value="'.$invoiceId.'">
		<input type="hidden" name="description" 	value="'.$description.'">
		<input type="hidden" name="amount" 			value="'.$amount.'">
		<input type="hidden" name="currencyCode" 	value="'.$currencyCode.'">	
		<input type="hidden" name="firstname" 	 	value="'.$firstname.'">
		<input type="hidden" name="lastname" 	 	value="'.$lastname.'">
		<input type="hidden" name="fullname" 	 	value="'.$fullname.'">
		<input type="hidden" name="email" 	 		value="'.$email.'">
		<input type="hidden" name="address1" 	 	value="'.$address1.'">
		<input type="hidden" name="address2" 	 	value="'.$address2.'">
		<input type="hidden" name="city" 	 		value="'.$city.'">		
		<input type="hidden" name="state" 	 		value="'.$state.'">
		<input type="hidden" name="postcode" 	 	value="'.$postcode.'">
		<input type="hidden" name="country" 	 	value="'.$country.'">
		<input type="hidden" name="phone" 	 		value="'.$phone.'">
	
		<input type="submit" value="Proceed Payment" name="Submit" class="btn btn-primary">

	</form><center>';

	return $code;
		
}

?>